import Bladex
import Doors
import Levers
import Locks
import Objects
import Sounds
import Button
import ReadGSFile
import AuxFuncs
import darfuncs
import Stars
import Reference
import EnemyTypes
import Sparks
import Actions
import ItemTypes
import GenFX
import EnmGenRnd
import OnOff
import LevelFuncs
import Auras
import Breakings
import Basic_Funcs
import Damage
import whrandom
import Scorer
import stone
import heavyObjects
import AniSound
import GameText


GameText.MapList ['VENGANCE'] = 'Vengance'
################################ SPECIAL COMBOS ##################################

bar=Bladex.GetCharType("Barbarian_N","Bar_N")

#Venom Axe
bar.AllowAttack("GM29_AXE","A+B","GM28_AXE","","GM28_AXE_Window","Hacha2hojas")

#Ice Sword
bar.AllowAttack("GM41_2H","R","GM7_2H","","","FlatSword")

#Hell Blade
bar.AllowAttack("GM42_2H","R+L","GI_2H","","GI_2H_Window","DeathSword")
bar.AllowAttack("GM9_2H","B","GM1_2H","","","DeathSword")

#Solar Blade
bar.AllowAttack("GM9_2H","B","GM1_2H","","","SawSword")
bar.AllowAttack("GM42_2H","R+L","GI_2H","","GI_2H_Window","SawSword")
bar.AllowAttack("GM41_2H","R","GM7_2H","","","SawSword")
bar.AllowAttack("GM15_2H","F","GM11_2H","","","SawSword")
#bar.AllowAttack("GM60_2H","&B","GI_2H","","","SawSword")

#Long Orksword
bar.AllowAttack("GM42_2H","R+L","GI_2H","","GI_2H_Window","LongSword")
bar.AllowAttack("GM9_2H","B","GM1_2H","","","LongSword")
##############

Reference.DefaultObjectData["Hacha2hojas"].append(['Venom', +10.0])
Reference.DefaultSelectionData['Hacha2hojas']=(8.0,4000.0,"Venom Axe")
Reference.DefaultObjectData['Hacha2hojas'][1] = 250


Reference.DefaultObjectData["FlatSword"].append(['Ice', +10.0])
Reference.DefaultSelectionData['FlatSword']=(8.0,4000.0,"Ice Sword")
Reference.DefaultObjectData['FlatSword'][1] = 300


Reference.DefaultObjectData["DeathSword"].append(['Drain'])
Reference.DefaultSelectionData["DeathSword"]=(8.0,4000.0,"Hell Blade")
Reference.DefaultObjectData['DeathSword'][1] = 400


Reference.DefaultObjectData["LongSword"].append(['Venom', +10.0])
Reference.DefaultSelectionData['LongSword']=(8.0,4000.0,"Long Orksword")
Reference.DefaultObjectData['LongSword'][1] = 550


############################################################################
##################### Enemy Magically Appearing Function ###################
############################################################################

def ChangeRasterMode2(ent_name, mode):
	Bladex.GetEntity(ent_name).RasterMode=mode

def EnemyMagicallyAppearing(enemy, xtm):
	TimeEffect=xtm
	time=Bladex.GetTime()
	char=Bladex.GetEntity(enemy)
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.4, 0.4, 1.0, 1.0, 0.2  ,  0.0, 0.3, 0.9, 0.0, 0.7)
	AuraGradient1=(2,  0.1, 0.2, 0.9, 1.0, 0.2  ,  0.6, 0.6, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(enemy, TimeEffect, AuraParams0, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams2, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSEnemyMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=enemy
	ps.ParticleType="FastEnergyConc"
	ps.PPS=400  #200
	ps.YGravity=-800     #0.0 # -300! #-800 !!
	ps.Friction=0.5 ############0.01
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=-2.0
	ps.Time2Live=30     # 30
	ps.DeathTime=time+TimeEffect/2.0

############ door sounds ###########################

sdoor1d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-deslizando.wav", "MaderaDesliz")
sdoor1d.MaxDistance=20000
sdoor1d.MinDistance=1000
sdoor1d.Volume=1.0

sdoor1g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-golpe.wav", "MaderaGolpe")
sdoor1g.MaxDistance=20000
sdoor1g.MinDistance=2000
sdoor1g.Volume=1.0

sdoor1b=Sounds.CreateEntitySound("..\\..\\Sounds\\block-sliding.wav", "Block")
sdoor1b.MaxDistance=20000
sdoor1b.MinDistance=2000
sdoor1b.Volume=1.0



def unhidearch1():

	darfuncs.UnhideBadGuy("arch1")

def unhidetorchmin():

	darfuncs.UnhideBadGuy("Minot0")

def unhidetun2():

	darfuncs.UnhideBadGuy("tun2")

def unhidetun1():

	darfuncs.UnhideBadGuy("tun1")

def unhidetkngt2():

	darfuncs.UnhideBadGuy("tkngt2")

def unhidetkngt1():

	darfuncs.UnhideBadGuy("tkngt1")

def unhidedkngt():

	darfuncs.UnhideBadGuy("dkngt")

def unhidearch2():

	darfuncs.UnhideBadGuy("arch2")
	
def unhidearch3():

	darfuncs.UnhideBadGuy("arch3")
	
def unhidearch4():

	darfuncs.UnhideBadGuy("arch4")
	
def unhidedkngt1():

	darfuncs.UnhideBadGuy("dkngt1")
	
def unhidedkngt2():

	darfuncs.UnhideBadGuy("dkngt2")
	
def unhidedsgolem():

	darfuncs.UnhideBadGuy("sgolem")

def ChaosMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())

def unhideddemon1():

	darfuncs.UnhideBadGuy("demon1")
	
def unhideddemon2():

	darfuncs.UnhideBadGuy("demon2")
	
def unhidetkngtv1():

	darfuncs.UnhideBadGuy("tkngtv1")

def unhidetkngtv2():

	darfuncs.UnhideBadGuy("tkngtv2")
	
def unhidedkngtv3():

	darfuncs.UnhideBadGuy("dkngtv3")
	
def Abredoor4():
	door4.OpenDoor()
def Cierradoor4():
	door4.CloseDoor()


def ExtraChaosFunc(entity):
	Abredoor4()
	ChaosMatrix()
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,ChaosDisappear,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,ChaosVanish,())

def NewChaosDeadFunc(entity):
	ExtraChaosFunc(entity)



def unhideck1():

	darfuncs.UnhideBadGuy("ck1")


def ChaosVanish():
	pers=Bladex.GetEntity("ck1")
	pers.CastShadows=0
	o=Bladex.GetEntity("cks1")
	o.CastShadows=0
	o=Bladex.GetEntity("cksh1")
	o.CastShadows=0

def ChaosDisappear():
	EnemyMagicallyAppearing("ck1",9)
	o=Bladex.GetEntity("ck1")
	o.Alpha=0.01
	o=Bladex.GetEntity("cksh1")
	o.Alpha=0.01
	o=Bladex.GetEntity("cks1")
	o.Alpha=0.01



def MinoMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())


	
def Abredoor6():
	door6.OpenDoor()
def Cierradoor6():
	door6.CloseDoor()





def ExtraMinoFunc(entity):
	Abredoor6()
	MinoMatrix()

def NewMinoDeadFunc(entity):
	ExtraMinoFunc(entity)

######### stone club mino on bridge ###########

def unhidestmin():

	darfuncs.UnhideBadGuy("stmin")





def VampMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())


	
def Abredoor9():
	door9.OpenDoor()
def Cierradoor9():
	door9.CloseDoor()



def Abredoor2():
	door2.OpenDoor()
def Cierradoor2():
	door2.CloseDoor()

	
def AbredoorF():
	doorF.OpenDoor()
def CierradoorF():
	doorF.CloseDoor()
	
def Abredoor1():
	door1.OpenDoor()
def Cierradoor1():
	door1.CloseDoor()

def Abredoor3():
	door3.OpenDoor()
def Cierradoor3():
	door3.CloseDoor()
	
def AbredoorW():
	doorW.OpenDoor()
def CierradoorW():
	doorW.CloseDoor()



def ExtraVampFunc(entity):
	AbredoorF()
	Abredoor9()
	VampMatrix()

def NewVampDeadFunc(entity):
	ExtraVampFunc(entity)



def unhidevamp():

	darfuncs.UnhideBadGuy("vamp")





def DemonMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())

darfuncs.EnterSecEvent( -31000, -14000, -4000, DemonMatrix)



def D_DemonMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())



def Abredoor11():
	door11.OpenDoor()
def Cierradoor11():
	door11.CloseDoor()
	
def Abredoor5():
	door5.OpenDoor()
def Cierradoor5():
	door5.CloseDoor()
	
def AbredoorM():
	doorM.OpenDoor()
def CierradoorM():
	doorM.CloseDoor()
	
def Abredoor7():
	door7.OpenDoor()
def Cierradoor7():
	door7.CloseDoor()
	
def Abredoor8():
	door8.OpenDoor()
def Cierradoor8():
	door8.CloseDoor()
	
def Abredoor10():
	door10.OpenDoor()
def Cierradoor10():
	door10.CloseDoor()

def AbredoorCH():
	doorCH.OpenDoor()
def CierradoorCH():
	doorCH.CloseDoor()



def AbredoorI():
	doorI.OpenDoor()
def CierradoorI():
	doorI.CloseDoor()
	

def ExtraDemonFunc(entity):
	exit(entity)
	D_DemonMatrix()

def NewDemonDeadFunc(entity):
	ExtraDemonFunc(entity)



def unhidegreatdemon():

	darfuncs.UnhideBadGuy("greatdemon")



def entrance(entity):
	dinobj = Objects.CreateDinamicObject("bridgeeast")
	Objects.DisplaceObjectFromTo(dinobj, (-30500, -13700, -4000), (-38500, -13700, -4000), 1000, 1000, "", "", "", "", "", "", "")

darfuncs.EnterSecEvent( -35000, -14000, -4000, entrance)



def exit(entity):
	dinobj = Objects.CreateDinamicObject("bridgewest")
	Objects.DisplaceObjectFromTo(dinobj, (-47500, -13700, -4000), (-55500, -13700, -4000), 1000, 1000, "", "", "", "", "", Abredoor11, ())

############################### Chaos Bridge Walk #########################

def Chaos_bridgewalk():
	pers=Bladex.GetEntity("Player1")
	pers.GoToJogging = 0
	pers.GoTo( -148000, -18000, 39000)

darfuncs.EnterSecEvent( -138000, -18000, 39000, Chaos_bridgewalk)

def BridgeMatrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())

darfuncs.EnterSecEvent( -141000, -18000, 39000, BridgeMatrix)





def gate(entity):
	dinobj = Objects.CreateDinamicObject("gate")
	Objects.DisplaceObjectFromTo(dinobj, (-138000, -27500, 39000), (-138000, -20500, 39000), 2500, 2500, "", "", "", "", "", "", "")

darfuncs.EnterSecEvent( -141000, -18000, 39000, gate)



def Chaos2Matrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())


	
def AbredoorCK2():
	doorCK2.OpenDoor()
def CierradoorCK2():
	doorCK2.CloseDoor()





def ExtraChaos2Func(entity):
	AbredoorCK2()
	Chaos2Matrix()
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,Chaos2Disappear,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,Chaos2Vanish,())

def NewChaos2DeadFunc(entity):
	ExtraChaos2Func(entity)



def unhideck2():

	darfuncs.UnhideBadGuy("ck2")



def Chaos2Vanish():
	pers=Bladex.GetEntity("ck2")
	pers.CastShadows=0

def Chaos2Disappear():
	EnemyMagicallyAppearing("ck2",9)
	o=Bladex.GetEntity("ck2")
	o.Alpha=0.01



def D_Demon2Matrix():
	darfuncs.StartMatrixFX(ESource = "Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.5,darfuncs.StopMatrixFX,())


	
def AbredoorEX1():
	doorEX1.OpenDoor()
def CierradoorEX1():
	doorEX1.CloseDoor()





def ExtraDemon2Func(entity):
	AbredoorEX1()
	AbredoorEX2()
	D_Demon2Matrix()

def NewDemon2DeadFunc(entity):
	ExtraDemon2Func(entity)


	
def AbredoorEX2():
	doorEX2.OpenDoor()
def CierradoorEX2():
	doorEX2.CloseDoor()



def unhideCHURCHdemon():

	darfuncs.UnhideBadGuy("CHURCHdemon")

def unhiderm1ork():

	darfuncs.UnhideBadGuy("rm1ork")
	
def unhidetork():

	darfuncs.UnhideBadGuy("topork")
	
def unhidecavork1():

	darfuncs.UnhideBadGuy("cavork1")
	
def unhidecavork2():

	darfuncs.UnhideBadGuy("cavork2")
	
def unhidehillork():

	darfuncs.UnhideBadGuy("hillork")
	
def unhidehillork1():

	darfuncs.UnhideBadGuy("hillork1")
	
def unhidehillork2():

	darfuncs.UnhideBadGuy("hillork2")
	
def unhidehillork3():

	darfuncs.UnhideBadGuy("hillork3")
	
def unhidetrls():
	darfuncs.UnhideBadGuy("trol1")
	darfuncs.UnhideBadGuy("trol2")
	darfuncs.UnhideBadGuy("trol3")
	
def unhidegork():

	darfuncs.UnhideBadGuy("gork")
	
def unhidestork():

	darfuncs.UnhideBadGuy("stork")
	
def unhidecavorkS():

	darfuncs.UnhideBadGuy("cavorkS")
	
def unhidecavorkF():

	darfuncs.UnhideBadGuy("cavorkF")
	
def unhidetrolH():

	darfuncs.UnhideBadGuy("trolH")
	
def unhideMinot1():

	darfuncs.UnhideBadGuy("Minot1")

def unhidedkngth1():

	darfuncs.UnhideBadGuy("dkngth1")

def unhidedkngth2():

	darfuncs.UnhideBadGuy("dkngth2")
	
def unhidedkngth3():

	darfuncs.UnhideBadGuy("dkngth3")
	
def unhidedkngtc1():

	darfuncs.UnhideBadGuy("dkngtc1")
	
def unhidedkngtc2():

	darfuncs.UnhideBadGuy("dkngtc2")
	
def unhidedkngtc3():

	darfuncs.UnhideBadGuy("dkngtc3")
	
def unhidesork1():

	darfuncs.UnhideBadGuy("sork1")
	
def unhidesork2():

	darfuncs.UnhideBadGuy("sork2")
	
def unhideMinotH():

	darfuncs.UnhideBadGuy("MinotH")
	
def unhidetrolH1():

	darfuncs.UnhideBadGuy("trolH1")
	
def unhidetrolH2():

	darfuncs.UnhideBadGuy("trolH2")
	
def unhidedTgolem():

	darfuncs.UnhideBadGuy("Tgolem")





def Dgate(entity):
	dinobj = Objects.CreateDinamicObject("Dgate")
	Objects.DisplaceObjectFromTo(dinobj, (-87000, -29250, -60500), (-87000, -24750, -60500), 2500, 2500, "", "", "", "", "", "", "")

darfuncs.EnterSecEvent( -87000, -22500, -57000, Dgate)

##################### DAL GURAK ################

def unhideGenDalGurak3():

	darfuncs.UnhideBadGuy("GenDalGurak3")

def DalIsDead(entity):
	darfuncs.StartMatrixFX(ESource = "GenDalGurak3")
	Bladex.AddScheduledFunc(Bladex.GetTime()+200.0,darfuncs.StopMatrixFX,())

def MuereDalGurak(entity):
	DalIsDead(entity)

gen_DalGurak3 = EnmGenRnd.CreateEnemy((-87000, -23767, -35000),"GenDalGurak3", "DalGurak", "", 0, "", 0, 9)
gen_DalGurak3.Angle = 3.0

gen_DalGurak3.Data.VeryOldImDeadFunc = gen_DalGurak3.ImDeadFunc
gen_DalGurak3.ImDeadFunc = MuereDalGurak

gen_DalGurak3.Data.positionlist.append([-92000, -23767, -38000, 0])
gen_DalGurak3.Data.positionlist.append([-82000, -23767, -38000, 0])
gen_DalGurak3.Data.positionlist.append([-92000, -23767, -50000, 0])
gen_DalGurak3.Data.positionlist.append([-82000, -23767, -50000, 0])
gen_DalGurak3.Data.positionlist.append([-87000, -23767, -35000, 0])
gen_DalGurak3.Data.positionlist.append([-87000, -23767, -53000, 0])

dalinv= gen_DalGurak3.GetInventory()

gen_DalGurak3.Data.Dalweapon=Bladex.CreateEntity("DalWeapon", "DalWeapon", 0,0,0, "Weapon")
ItemTypes.ItemDefaultFuncs(gen_DalGurak3.Data.Dalweapon)
dalinv.AddWeapon(gen_DalGurak3.Data.Dalweapon.Name)

gen_DalGurak3.Data.Dalshield=Bladex.CreateEntity("DalShield","DalShield",0,0,0, "Weapon")
Sparks.MakeShield(gen_DalGurak3.Data.Dalshield.Name)
dalinv.AddShield(gen_DalGurak3.Data.Dalshield.Name)

dalmagicshield= ItemTypes.MakeMagicShield("DalMagicShield", gen_DalGurak3)

darfuncs.HideBadGuy("GenDalGurak3")
darfuncs.EnterSecEvent( -87000, -22500, -55000, unhideGenDalGurak3)