import Bladex
# from math import pow
import Reference
import EnemyTypes
import Sparks
import Actions
import pocimac
import Breakings
import ItemTypes
import darfuncs

import EnmGenRnd
import AuxFuncs
import OnOff

import LevelFuncs

import Doors
import Levers
import Locks
import Objects
import Sounds
import Button
import ReadGSFile
import Stars

### Set these values to the expected player's level (0-19) at the beginning of the map
expected_player_lvl_min= 9
expected_player_lvl_max= 19

lvl_control=LevelFuncs.EnemyLevelControl (expected_player_lvl_min, expected_player_lvl_max)
### e.g. to give an enemy a level between 0 and 4, do
### pers.Level= lvl_control.GiveLevel(0, 4)




################## great ork in water cave



o=Bladex.CreateEntity("TombEspada5","Orksword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("TombEscudo5","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("rm1ork","Great_Ork",-26000, -1118, 20000,"Person")
pers.Angle=0
pers.Level=14
Actions.TakeObject(pers.Name,"TombEspada5")
Actions.TakeObject(pers.Name,"TombEscudo5")

pers.Blind       = 1
pers.Deaf        = 1




EnemyTypes.EnemyDefaultFuncs(pers)



pers.SetOnFloor()

darfuncs.HideBadGuy("rm1ork")

darfuncs.EnterSecEvent(-18000, 1000, 29000, unhiderm1ork)



################### ork with bow ###################



pers=Bladex.CreateEntity("topork","Ork", 15000, -10618, 35500,"Person")
pers.Angle=2.25
pers.Level=14
pers.SetOnFloor()

bowtop=Bladex.CreateEntity("toporkbow","Arco2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bowtop)
Actions.TakeObject(pers.Name,bowtop.Name)

quivertop=Bladex.CreateEntity("toporkquiver","Carcaj",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (quivertop)
quivertop.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,quivertop.Name)

swordtop=Bladex.CreateEntity("toporksword","Hacha",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(swordtop)
Actions.TakeObject(pers.Name,swordtop.Name)

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("topork")

darfuncs.EnterSecEvent(2500, -3500, 17000, unhidetork)



################### orks in hill cave

#####  ork1  ####



o=Bladex.CreateEntity("cavsword1","Espadacurva",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("cavsheild1","Escudo1",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("cavork1","Ork", 20000, -10618, 57000,"Person")
pers.Angle=3
pers.Level=14
Actions.TakeObject(pers.Name,"cavsword1")
Actions.TakeObject(pers.Name,"cavsheild1")

pers.Blind       = 1
pers.Deaf        = 1




EnemyTypes.EnemyDefaultFuncs(pers)



pers.SetOnFloor()

darfuncs.HideBadGuy("cavork1")

darfuncs.EnterSecEvent(18000, -6000, 32000, unhidecavork1)


######  ork2  ####




o=Bladex.CreateEntity("cavsword2","Hacha4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("cavsheild2","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

rat=Bladex.CreateEntity("rations","Saquito",0,0,0,"Physic")
rat.Scale=1.220190
pocimac.CreatePotion("rations")

pers=Bladex.CreateEntity("cavork2","Ork", 22000, -10618, 59000,"Person")
pers.Angle=3
pers.Level=15
Actions.TakeObject(pers.Name,"cavsword2")
Actions.TakeObject(pers.Name,"cavsheild2")
Actions.TakeObject(pers.Name,"rations")

pers.Blind       = 1
pers.Deaf        = 1




EnemyTypes.EnemyDefaultFuncs(pers)



pers.SetOnFloor()

darfuncs.HideBadGuy("cavork2")

darfuncs.EnterSecEvent(18000, -6000, 32000, unhidecavork2)

############################ Trolls #########################

pers=Bladex.CreateEntity("trol1","Troll_Dark", 43000, -5118, 69000,"Person")
pers.Angle=2.25
pers.Level=7
pers.Scale=1
pers.SetOnFloor()
o=Bladex.CreateEntity("Trl1","Hachacarnicero",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Blind       = 1
pers.Deaf        = 1
darfuncs.HideBadGuy("trol1")

pers=Bladex.CreateEntity("trol2","Troll_Dark", 54000, -5118, 70000,"Person")
pers.Angle=0.75
pers.Level=8
pers.Scale=1
pers.SetOnFloor()
o=Bladex.CreateEntity("Trl2","Hachacarnicero",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Blind       = 1
pers.Deaf        = 1
darfuncs.HideBadGuy("trol2")

pers=Bladex.CreateEntity("trol3","Troll_Dark", 45000, -5118, 56000,"Person")
pers.Angle=5.25
pers.Level=9
pers.Scale=1
pers.SetOnFloor()
o=Bladex.CreateEntity("Trl3","Hachacarnicero",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Blind       = 1
pers.Deaf        = 1
darfuncs.HideBadGuy("trol3")


darfuncs.EnterSecEvent(34000, -4000, 61000, unhidetrls)




################### ork with bow on hill ###################



pers=Bladex.CreateEntity("hillork","Ork", -10000, -15118, 16000,"Person")
pers.Angle=4.5
pers.Level=19
pers.SetOnFloor()

o=Bladex.CreateEntity("hillorkbow","Arco2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)

o=Bladex.CreateEntity("hillorkquiver","CarcajFuego",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (o)
o.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,o.Name)

o=Bladex.CreateEntity("hillorksword","Hacha6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)

o=Bladex.CreateEntity("hillorkpot","Pocima200",0,0,0,"Physic")
o.Scale=1.220190
pocimac.CreatePotion("hillorkpot")
Actions.TakeObject(pers.Name,"hillorkpot")

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("hillork")

darfuncs.EnterSecEvent(2500, -3500, 17000, unhidehillork)



################ orks on hill ###########

#####  ork1  ####



o=Bladex.CreateEntity("hillsword1","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("hillsheild1","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("hillork1","Great_Ork", 11000, -15118, -20000,"Person")
pers.Angle=1.5
pers.Level=19
Actions.TakeObject(pers.Name,"hillsword1")
Actions.TakeObject(pers.Name,"hillsheild1")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("hillork1")

darfuncs.EnterSecEvent( -6000, -14000, -32000, unhidehillork1)


#####  ork2  ####



o=Bladex.CreateEntity("hillsword2","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("hillsheild2","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("hillork2","Ork", 9000, -15118, -24000,"Person")
pers.Angle=1.5
pers.Level=19
Actions.TakeObject(pers.Name,"hillsword2")
Actions.TakeObject(pers.Name,"hillsheild2")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("hillork2")

darfuncs.EnterSecEvent( -6000, -14000, -32000, unhidehillork2)

#####  ork3  ####



o=Bladex.CreateEntity("hillsword3","EgyptSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("hillsheild3","Escudo9",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("hillork3","Ork", -17000, -15118, -6000,"Person")
pers.Angle=3.0
pers.Level=19
Actions.TakeObject(pers.Name,"hillsword3")
Actions.TakeObject(pers.Name,"hillsheild3")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("hillork3")

darfuncs.EnterSecEvent( -6000, -14000, -32000, unhidehillork3)