import Bladex
# from math import pow
import Reference
import EnemyTypes
import Sparks
import Actions
import pocimac
import Breakings
import ItemTypes
import darfuncs
import GenFX

import EnmGenRnd
import AuxFuncs
import OnOff

import LevelFuncs

import Doors
import Levers
import Locks
import Objects
import Sounds
import Button
import ReadGSFile
import Stars

### Set these values to the expected player's level (0-19) at the beginning of the map
expected_player_lvl_min= 9
expected_player_lvl_max= 19

lvl_control=LevelFuncs.EnemyLevelControl (expected_player_lvl_min, expected_player_lvl_max)
### e.g. to give an enemy a level between 0 and 4, do
### pers.Level= lvl_control.GiveLevel(0, 4)



########### dark knight + 2 traitor knights #########

########### dark ############



o=Bladex.CreateEntity("double","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("small","Escudo3",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

full=Bladex.CreateEntity("thou","Pocima200",0,0,0,"Physic")
full.Scale=1.220190
pocimac.CreatePotion("thou")

pers=Bladex.CreateEntity("dkngt","Dark_Knight", 84000, -12118, 28000,"Person")
pers.Angle=3
pers.Level=15
Actions.TakeObject(pers.Name,"double")
Actions.TakeObject(pers.Name,"small")
Actions.TakeObject(pers.Name,"thou")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("dkngt")

darfuncs.EnterSecEvent( 69000, -11000, 34000, unhidedkngt)



######################### Traitors ###############

########## traitor 1 #########



o=Bladex.CreateEntity("dag","Dagesse",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("wall1","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tkngt1","Knight_Traitor", 79000, -12118, 21000,"Person")
pers.Angle=1.5
pers.Level=19
Actions.TakeObject(pers.Name,"dag")
Actions.TakeObject(pers.Name,"wall1")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tkngt1")

darfuncs.EnterSecEvent( 69000, -11000, 34000, unhidetkngt1)


########## traitor 2 ############




o=Bladex.CreateEntity("cim","Cimitarra",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("wall2","Escudo4",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tkngt2","Knight_Traitor", 89000, -12118, 21000,"Person")
pers.Angle=4.5
pers.Level=19
Actions.TakeObject(pers.Name,"cim")
Actions.TakeObject(pers.Name,"wall2")

pers.Blind       = 0
pers.Deaf        = 0

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tkngt2")

darfuncs.EnterSecEvent( 69000, -11000, 34000, unhidetkngt2)


########## traitor knights by tunnel exit #########


####### tunnel knight 1 #####



o=Bladex.CreateEntity("tdag","Dagesse",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("tunshield1","Escudo8",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tun1","Knight_Traitor", 63500, -12118, 43500,"Person")
pers.Angle=3.75
pers.Level=18
Actions.TakeObject(pers.Name,"tdag")
Actions.TakeObject(pers.Name,"tunshield1")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tun1")

darfuncs.EnterSecEvent( 51000, -6000, 45000, unhidetun1)


####### tunnel knight 2 #####




o=Bladex.CreateEntity("curve","Espadacurva",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("tunshield2","Escudo8",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tun2","Knight_Traitor", 64000, -12118, 34000,"Person")
pers.Angle=0.75
pers.Level=18
Actions.TakeObject(pers.Name,"curve")
Actions.TakeObject(pers.Name,"tunshield2")

pers.Blind       = 0
pers.Deaf        = 0

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tun2")

darfuncs.EnterSecEvent( 51000, -6000, 45000, unhidetun2)


########### minotaur in torcher room ###########




o=Bladex.CreateEntity("cleaver","Hachacarnicero",0,0,0,"Weapon")
pers=Bladex.CreateEntity("Minot0","Minotaur", 102500, -11118, 38500,"Person")
pers.Level=7
pers.Angle=2.25
Actions.TakeObject(pers.Name,"cleaver")
pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy(pers.Name)

darfuncs.EnterSecEvent( 101000, -11000, 33000, unhidetorchmin)


########## dark knights with bows on bridge ##########

###### north archer 1 ########



pers=Bladex.CreateEntity("arch1","Dark_Knight", 72000, -14118, 4500,"Person")
pers.Angle=3
pers.Level=0
pers.SetOnFloor()

bow=Bladex.CreateEntity("bow1","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(pers.Name,"bow1")

quiver=Bladex.CreateEntity("quiver1","Carcaj",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,"quiver1")

sword=Bladex.CreateEntity("sword1","Hacha",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(sword)
Actions.TakeObject(pers.Name,sword.Name)

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("arch1")

darfuncs.EnterSecEvent( 84000, -11000, 2000, unhidearch1)

###### north archer 2 ########



pers=Bladex.CreateEntity("arch2","Dark_Knight", 96000, -14118, 4500,"Person")
pers.Angle=3
pers.Level=0
pers.SetOnFloor()

bow=Bladex.CreateEntity("bow2","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(pers.Name,"bow2")

quiver=Bladex.CreateEntity("quiver2","Carcaj",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,"quiver2")

sword=Bladex.CreateEntity("sword2","Hacha",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(sword)
Actions.TakeObject(pers.Name,sword.Name)

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("arch2")

darfuncs.EnterSecEvent( 84000, -11000, 2000, unhidearch2)

###### south archer 3 ########



pers=Bladex.CreateEntity("arch3","Dark_Knight", 72000, -14118, -19500,"Person")
pers.Angle=0
pers.Level=0
pers.SetOnFloor()

bow=Bladex.CreateEntity("bow3","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(pers.Name,"bow3")

quiver=Bladex.CreateEntity("quiver3","Carcaj",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,"quiver3")

sword=Bladex.CreateEntity("sword3","Hacha",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(sword)
Actions.TakeObject(pers.Name,sword.Name)

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("arch3")

darfuncs.EnterSecEvent( 84000, -11000, 2000, unhidearch3)

###### south archer 4 ########



pers=Bladex.CreateEntity("arch4","Dark_Knight", 96000, -14118, -19500,"Person")
pers.Angle=0
pers.Level=0
pers.SetOnFloor()

bow=Bladex.CreateEntity("bow4","Arco",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(bow)
Actions.TakeObject(pers.Name,"bow4")

quiver=Bladex.CreateEntity("quiver4","Carcaj",0,0,0,"Physic")
ItemTypes.ItemDefaultFuncs (quiver)
quiver.Data.SetNumberOfArrows(10, pers.Name)
Actions.TakeObject(pers.Name,"quiver4")

sword=Bladex.CreateEntity("sword4","Hacha",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(sword)
Actions.TakeObject(pers.Name,sword.Name)

EnemyTypes.EnemyDefaultFuncs(pers)

darfuncs.HideBadGuy("arch4")

darfuncs.EnterSecEvent( 84000, -11000, 2000, unhidearch4)



############### 2 dark knights in ice axe room ##################


########### Dark Knight 1 ##############




o=Bladex.CreateEntity("Axe","Hacha2",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("Skull01","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("dkngt1","Dark_Knight", 82000, -17118, -42000,"Person")
pers.Angle=0
pers.Level=16
Actions.TakeObject(pers.Name,"Axe")
Actions.TakeObject(pers.Name,"Skull01")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("dkngt1")

darfuncs.EnterSecEvent( 84000, -15500, -31000, unhidedkngt1)




########### Dark Knight 2 ##############





o=Bladex.CreateEntity("sharpsword","Espadafilo",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("Skull02","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("dkngt2","Dark_Knight", 86000, -17118, -42000,"Person")
pers.Angle=0
pers.Level=16
Actions.TakeObject(pers.Name,"sharpsword")
Actions.TakeObject(pers.Name,"Skull02")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("dkngt2")

darfuncs.EnterSecEvent( 84000, -15500, -31000, unhidedkngt2)


############# Stone Golem ##############




pers=Bladex.CreateEntity("sgolem","Golem_stone", 91500, -17117, -42000,"Person")
pers.Angle=1.5
pers.Level=9

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("sgolem")

darfuncs.EnterSecEvent( 84000, -16000, -48000, unhidedsgolem)


############# 2 small demons ################

########### demon1 #############



pers=Bladex.CreateEntity("demon1","Little_Demon", 27000, -9117, -81000,"Person")
pers.Angle=4.5
pers.Level=19

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("demon1")

darfuncs.EnterSecEvent( 52000, -8000, -73000, unhideddemon1)


########### demon2 #############



pers=Bladex.CreateEntity("demon2","Little_Demon", 27000, -9117, -83500,"Person")
pers.Angle=4.5
pers.Level=19

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("demon2")

darfuncs.EnterSecEvent( 52000, -8000, -73000, unhideddemon2)




######################### Vamp exit knights ###############

########## traitor 1 #########


o=Bladex.CreateEntity("hev1","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("heat1","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tkngtv1","Knight_Traitor", -8000, -15118, -32000,"Person")
pers.Angle=3.0
pers.Level=19
Actions.TakeObject(pers.Name,"hev1")
Actions.TakeObject(pers.Name,"heat1")

pers.Blind       = 1
pers.Deaf        = 1

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tkngtv1")

darfuncs.EnterSecEvent( -6000, -8000, -59000, unhidetkngtv1)


########## traitor 2 ############




o=Bladex.CreateEntity("hev2","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("heat2","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("tkngtv2","Knight_Traitor", -4000, -15118, -32000,"Person")
pers.Angle=3.0
pers.Level=19
Actions.TakeObject(pers.Name,"hev2")
Actions.TakeObject(pers.Name,"heat2")

pers.Blind       = 0
pers.Deaf        = 0

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("tkngtv2")

darfuncs.EnterSecEvent( -6000, -8000, -59000, unhidetkngtv2)



########## dark ############




o=Bladex.CreateEntity("hev3","Espada",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
o=Bladex.CreateEntity("heat3","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)

pers=Bladex.CreateEntity("dkngtv3","Dark_Knight", -6000, -15118, -28000,"Person")
pers.Angle=3.0
pers.Level=19
Actions.TakeObject(pers.Name,"hev3")
Actions.TakeObject(pers.Name,"heat3")

pers.Blind       = 0
pers.Deaf        = 0

EnemyTypes.EnemyDefaultFuncs(pers)

pers.SetOnFloor()

darfuncs.HideBadGuy("dkngtv3")

darfuncs.EnterSecEvent( -6000, -8000, -59000, unhidedkngtv3)